config/routes.rb
Rails.application.routes.draw do
  resources :dairy_details
  root 'dashboard#index'
  devise_for :users
  resources :customer_payments
  resources :rate_charts
  resources :daily_collections do
    collection do
      get 'payment_register'
      get 'daily_report'
    end
  end
  resources :customers

  get 'rate_by_snf_and_fat', to: 'rate_charts#rate_by_snf_and_fat'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/rate_chart.rb
class RateChart < ApplicationRecord
  attr_accessor :left, :top, :right, :bottom, :base_rate
end

app/controllers/rate_charts_controller.rb
class RateChartsController < ApplicationController
  before_action :set_rate_chart, only: [:show, :edit, :update, :destroy]
  load_and_authorize_resource
  # GET /rate_charts
  # GET /rate_charts.json
  def index
    @rate_charts = RateChart.where(cattle_type: params[:cattle_type])
  end

  # GET /rate_charts/1
  # GET /rate_charts/1.json
  def show
  end

  # GET /rate_charts/new
  def new
    @rate_chart = RateChart.new
  end

  # GET /rate_charts/1/edit
  def edit
  end

  # POST /rate_charts
  # POST /rate_charts.json
  def create

    @rate_charts = RateChart.where(cattle_type: rate_chart_params[:cattle_type])
    unless @rate_charts.nil?
      # @rate_charts.each do |rate|
      #   rate.destroy
      # end
      @rate_charts.destroy_all
    end
    left = rate_chart_params[:left].to_f
    right = rate_chart_params[:right].to_f
    top = rate_chart_params[:top].to_f
    bottom = rate_chart_params[:bottom].to_f

    base_rate = rate_chart_params[:base_rate].to_f

    exLeft = 0
    exright = 0
    exTop = 0
    exBottom = 0
    baseSNF = 8.5
    baseFAT = 3.5

    data = Array.new

    cattle_type_ = rate_chart_params[:cattle_type]

    puts "CAttle: #{cattle_type_} , Base Rate: #{base_rate}"

    if cattle_type_ === 'BUFFALO'
      exLeft = 7.5
      exright = 9.5
      exTop = 5.0
      exBottom = 9.4
      baseSNF = 9.0
      baseFAT = 6.0

    elsif cattle_type_ === 'COW'
      exLeft = 7.0
      exright = 9.0
      exTop = 2.5
      exBottom = 6.0
      baseSNF = 8.5
      baseFAT = 3.5
    end

    # i = baseSNF
    # j = baseFAT
    current_rate = base_rate

    (baseSNF.round(2)).step(exLeft.round(2), -0.1.round(2)) do |i|
      rate = current_rate.round(2)

      (baseFAT.round(2)).step(exTop.round(2), -0.1.round(2)) do |j|
        data.push({
                  cattle_type: cattle_type_,
                  snf: i.round(2),
                  fat: j.round(2),
                  rate: rate.round(2)
                  })
        rate = rate.round(2) - top.round(2)
      end
      current_rate = current_rate.round(2) - left.round(2)
    end

    current_rate = base_rate.round(2) + right.round(2)

    (baseSNF.round(2) + 0.1.round(2)).step(exright.round(2), 0.1.round(2)) do |i|
      rate = current_rate.round(2)

      (baseFAT.round(2)).step(exTop.round(2), -0.1.round(2)) do |j|
        data.push({
                      cattle_type: cattle_type_,
                      snf: i.round(2),
                      fat: j.round(2),
                      rate: rate.round(2)
                  })
        rate = rate.round(2) - top.round(2)
      end
      current_rate = current_rate.round(2) + right.round(2)
    end

    current_rate = base_rate.round(2) + bottom.round(2)

    (baseSNF.round(2)).step(exright.round(2), 0.1.round(2)) do |i|
      rate = current_rate.round(2)

      (baseFAT.round(2) + 0.1.round(2)).step(exBottom.round(2), 0.1.round(2)) do |j|
        data.push({
                      cattle_type: cattle_type_,
                      snf: i.round(2),
                      fat: j.round(2),
                      rate: rate.round(2)
                  })
        rate = rate.round(2) + bottom.round(2)
      end
      current_rate = current_rate.round(2) + right.round(2)
    end

    current_rate = (base_rate.round(2) + bottom.round(2)) - left.round(2)

    (baseSNF.round(2) - 0.1.round(2)).step(exLeft.round(2), -0.1.round(2)) do |i|
      rate = current_rate.round(2)

      (baseFAT.round(2) + 0.1.round(2)).step(exBottom.round(2), 0.1.round(2)) do |j|
        data.push({
                      cattle_type: cattle_type_,
                      snf: i.round(2),
                      fat: j.round(2),
                      rate: rate.round(2)
                  })
        rate = rate.round(2) + bottom.round(2)
      end
      current_rate = current_rate.round(2) - left.round(2)
    end

    puts data
    respond_to do |format|
      if RateChart.create(data)
        format.html { redirect_to rate_charts_path(cattle_type: cattle_type_), notice: 'Rate chart was successfully created.' }
      else
        format.html { redirect_to rate_charts_url, alert: 'Something went wrong while adding rates.' }
      end
    end
    # @rate_chart = RateChart.new(rate_chart_params)

    # respond_to do |format|
    #   if @rate_chart.save
    #     format.html { redirect_to @rate_chart, notice: 'Rate chart was successfully created.' }
    #     format.json { render :show, status: :created, location: @rate_chart }
    #   else
    #     format.html { render :new }
    #     format.json { render json: @rate_chart.errors, status: :unprocessable_entity }
    #   end
    # end
  end

  # PATCH/PUT /rate_charts/1
  # PATCH/PUT /rate_charts/1.json
  def update
    respond_to do |format|
      if @rate_chart.update(rate_chart_params)
        format.html { redirect_to @rate_chart, notice: 'Rate chart was successfully updated.' }
        format.json { render :show, status: :ok, location: @rate_chart }
      else
        format.html { render :edit }
        format.json { render json: @rate_chart.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /rate_charts/1
  # DELETE /rate_charts/1.json
  def destroy
    @rate_chart.destroy
    respond_to do |format|
      format.html { redirect_to rate_charts_url, notice: 'Rate chart was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def rate_by_snf_and_fat
    @rate_chart = RateChart.find_by(snf: params[:snf], fat: params[:fat], cattle_type: params[:cattle_type])

    respond_to do |format|
      if @rate_chart
        format.json {render json: @rate_chart}
      else
        format.json {render json: {error: "No Rate found."}}
      end
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_rate_chart
      @rate_chart = RateChart.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def rate_chart_params
      params.require(:rate_chart).permit(:cattle_type, :snf, :fat, :rate, :left, :right, :top, :bottom, :base_rate)
    end
end

app/helpers/rate_charts_helper.rb
module RateChartsHelper

end

app/views/rate_charts/_form.html.erb
<%= form_with(model: rate_chart, local: true, id: 'rate_chart_form') do |form| %>
  <% if rate_chart.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(rate_chart.errors.count, "error") %> prohibited this rate_chart from being saved:</h2>

      <ul>
      <% rate_chart.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group row">
    <%= form.label :cattle_type, class: 'col-sm-2 col-form-label' %>
    <div class="col-sm-10">
      <%= form.select :cattle_type, options_for_select(['COW', 'BUFFALO']),
                      {}, {class: 'form-control', onchange: 'getval(this);', tabIndex: 1} %>
    </div>
  </div>

  <div class="row">
    <div class="col-md-6 col-lg-6">
      <h3>
        <span class="badge badge-primary">
          Base SNF :  <span id="base_snf">8.5</span>
        </span>
      </h3>
    </div>
    <div class="col-md-6 col-lg-6">
      <h3>
        <span class="badge badge-primary">
          Base FAT :  <span id="base_fat">3.5</span>
        </span>
      </h3>
    </div>
  </div>


  <div class="card">
    <div class="card-header">
      Add Base rate
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-4 col-lg-4"></div>
        <div class="col-md-4 col-lg-4">
          <div class="form-group">
            <%= form.label 'Top (-)' %>
            <%= form.text_field :top, class: 'form-control', required: true,
                                pattern: '[0-9]+([\.,][0-9]+)?', step: '0.01',
                title: 'This should be a number with up to 2 decimal places.',
                                tabIndex: 3 %>
          </div>
        </div>
        <div class="col-md-4 col-lg-4"></div>
      </div>
      <div class="row">
        <div class="col-md-4 col-lg-4">
          <div class="form-group">
            <%= form.label 'Left (-)' %>
            <%= form.text_field :left, class: 'form-control', required: true,
                                pattern: '[0-9]+([\.,][0-9]+)?', step: '0.01',
                                title: 'This should be a number with up to 2 decimal places.',
                                tabIndex: 4 %>
          </div>
        </div>
        <div class="col-md-4 col-lg-4">
          <div class="form-group">
            <%= form.label 'Base Rate' %>
            <%= form.text_field :base_rate, class: 'form-control', required: true,
                                pattern: '[0-9]+([\.,][0-9]+)?', step: '0.01',
                                title: 'This should be a number with up to 2 decimal places.',
                                tabIndex: 2 %>
          </div>
        </div>
        <div class="col-md-4 col-lg-4">
          <div class="form-group">
            <%= form.label 'Right (+)' %>
            <%= form.text_field :right, class: 'form-control', required: true,
                                pattern: '[0-9]+([\.,][0-9]+)?', step: '0.01',
                                title: 'This should be a number with up to 2 decimal places.',
                                tabIndex: 5 %>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-4 col-lg-4"></div>
        <div class="col-md-4 col-lg-4">
          <div class="form-group">
            <%= form.label 'Bottom (+)' %>
            <%= form.text_field :bottom, class: 'form-control', required: true,
                                pattern: '[0-9]+([\.,][0-9]+)?', step: '0.01',
                                title: 'This should be a number with up to 2 decimal places.',
                                tabIndex: 6 %>
          </div>
        </div>
        <div class="col-md-4 col-lg-4"></div>
      </div>
    </div>
  </div>
  <br/>
  <div class="actions form-group">
    <%= form.submit 'Submit', class: 'btn btn-primary', tabIndex: 7 %>
  </div>
<% end %>

app/views/rate_charts/edit.html.erb
<div class="row">
  <div class="col-md-2 col-lg-2"></div>
  <div class="col-md-8 col-lg-8">
    <div class="card">
      <h4 class="card-header">
        Editing Rate Chart
      </h4>
      <div class="card-body">
        <%= render 'form', rate_chart: @rate_chart %>
      </div>
    </div>
  </div>
  <div class="col-md-2 col-lg-2"></div>
</div>

app/views/rate_charts/index.html.erb
<h1>Rate Charts - "<%= params[:cattle_type] %>"</h1>


<%

  exLeft = 0
  exright = 0
  exTop = 0
  exBottom = 0

  cattle_type_ = params[:cattle_type]

  if cattle_type_ === 'BUFFALO'
    exLeft = 7.5
    exright = 9.5
    exTop = 5.0
    exBottom = 9.4

  elsif cattle_type_ === 'COW'
    exLeft = 7.0
    exright = 9.0
    exTop = 2.5
    exBottom = 6.0
  end
%>
<table class="table table-bordered" id="rate_chart_table">
  <thead>
    <tr>
      <th>###</th>
      <% (exLeft.round(2)).step(exright.round(2), 0.1.round(2)) do |i| %>
        <th><%= i %></th>
      <% end %>
    </tr>
  </thead>

  <tbody>
    <% (exTop.round(2)).step(exBottom.round(2), 0.1.round(2)) do |i| %>
      <tr>
        <th><%= i.round(2) %></th>
        <% (exLeft.round(2)).step(exright.round(2), 0.1.round(2)) do |j| %>
          <td>
            <% @rates = @rate_charts.where(snf: j.round(2), fat: i.round(2)).last %>
            <% unless @rates.nil? %>
              <%= @rates.rate %>
            <% end %>
          </td>
        <% end %>
      </tr>
    <% end %>


  </tbody>
</table>

app/views/rate_charts/new.html.erb
<div class="row">
  <div class="col-md-2 col-lg-2"></div>
  <div class="col-md-8 col-lg-8">
    <div class="card">
      <h4 class="card-header">
        New Rate Chart
      </h4>
      <div class="card-body">
        <%= render 'form', rate_chart: @rate_chart %>
      </div>
    </div>
  </div>
  <div class="col-md-2 col-lg-2"></div>
</div>

app/views/rate_charts/show.html.erb
<p>
  <strong>Cattle type:</strong>
  <%= @rate_chart.cattle_type %>
</p>

<p>
  <strong>Snf:</strong>
  <%= @rate_chart.snf %>
</p>

<p>
  <strong>Fat:</strong>
  <%= @rate_chart.fat %>
</p>

<p>
  <strong>Rate:</strong>
  <%= @rate_chart.rate %>
</p>

<%= link_to 'Edit', edit_rate_chart_path(@rate_chart), class: 'btn btn-primary' %> |
<%= link_to 'Back', rate_charts_path, class: 'btn btn-secondary' %>